#include "QdpFtdcTraderApi.h"
#include <iostream>
#include <cstdlib>
#include <string.h>
#include <stdio.h>
#include <thread>
#include <chrono>

#ifdef WIN32
#define WINDOWS
#endif
using namespace std;

// 报单录入操作是否完成的标志
// 经纪公司代码
TQdpFtdcBrokerIDType g_chBrokerID;
// 交易用户代码
TQdpFtdcUserIDType g_chUserID;
// 投资者编号
TQdpFtdcInvestorIDType g_chInvestorID;
// 用户本地最大报单号
int g_nOrdLocalID = 0;
/// 交易API
CQdpFtdcTraderApi *g_pTraderApi = NULL;

void OrderFunc();

void ReqQryTopic(int RequestID);

void ReqUserPasswordUpdate(int RequestID);

void ReqSubPrdTradeFlow(int RequestID);

void ReqUnSubPrdTradeFlow(int RequestID);

void ReqForQuoteInsert(int RequestID);

void ReqQryForQuote(int RequestID);

void ReqQryMarketData(int RequestID);

void ReqQryExchange(int &RequestID);

void ReqQryTrade(int &RequestID);

void ReqQryOrder(int &RequestID);

void ReqQuoteAction(int RequestID);

void ReqQuoteInsert(int RequestID);

void ReqSubmitUserSystemInfo(int RequestID);

void ReqQryFrontInfo(int RequestID);

int ReqSetClientMaxSigVol(int RequestID);

int ReqOrderAction(int RequestID);

int ReqOrderInsert(int RequestID);

int ReqQryUserInvestor(int RequestID);

int ReqQryInvestorAccount(int RequestID);

int ReqQryInvestorOptionFee(int RequestID);

int ReqQryInvestorMargin(int RequestID);

int ReqQryInstrument(int RequestID);

int ReqQrySGEDeferRate(int RequestID);

int ReqQryInvestorFee(int RequestID);

int ReqQryInvestorPosition(int RequestID);

class CTraderSpi : public CQdpFtdcTraderSpi
{
public:
    CTraderSpi(CQdpFtdcTraderApi *pUserApi) : m_pTraderApi(pUserApi) {}
    ~CTraderSpi() {orderThread.join();};

    // 实现CTraderSpi的各个接口
    virtual void OnFrontConnected()
    {
        std::cout << "OnFrontConnected\n";
        //连接后登录
        ReqLogin();
        //连接后认证
        ReqAuth();
    };

    void ReqLogin()
    {
        CQdpFtdcReqUserLoginField reqUserLogin;

        strcpy(reqUserLogin.UserProductInfo, "test");
        strcpy(reqUserLogin.BrokerID, g_chBrokerID);
        strcpy(reqUserLogin.UserID, g_chUserID);
        strcpy(reqUserLogin.Password, "1");
        // 发出登陆请求
        m_pTraderApi->ReqUserLogin(&reqUserLogin, 0);
    }

    void ReqAuth()
    {
        CQdpFtdcAuthenticateField reqfield;
        strcpy(reqfield.BrokerID, g_chBrokerID);
        strcpy(reqfield.UserID, g_chUserID);
        strcpy(reqfield.UserProductInfo, "test");
        strcpy(reqfield.AppID, "quantdo_InfiniV8_1");
        strcpy(reqfield.AuthCode, "58ba7c405b18960d31870d5095bfd06a");
        // 发出认证请求
        m_pTraderApi->ReqAuthenticate(&reqfield, 0);
    }

    virtual void OnFrontDisconnected(int nReason) {
        std::cout << "连接断开..." << "\n";
    };

    virtual void OnRspUserLogin(CQdpFtdcRspUserLoginField *pRspUserLogin, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "用户: " << g_chUserID << "登录失败; 原因: " << pRspInfo->ErrorMsg;
            // REPORT_EVENT(LOG_ERROR, "CTraderSpi::OnRspUserLogin", "Login result: %s", "failed");
            return;
        }
        
        std::cout << "登录成功，开始报单..." << "\n";

        // 启动独立线程用于报单和查询 防止堵塞回调
        orderThread = std::thread(OrderFunc);
    };

    virtual void OnRspUserLogout(CQdpFtdcRspUserLogoutField *pRspUserLogout, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if(pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "用户登出失败;原因:" << pRspInfo->ErrorMsg << "\n";
            return;
        }
        if(pRspInfo == NULL){
            std::cout << "OnRspUserLogout=NULL!\n";
        }
    };

    virtual void OnRspUserPasswordUpdate(CQdpFtdcUserPasswordUpdateField *pUserPasswordUpdate, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if(pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "用户更新密码失败;原因:" << pRspInfo->ErrorMsg << "\n";
            return;
        }
        if(pRspInfo == NULL){
            std::cout << "OnRspUserPasswordUpdate=NULL!\n";
        }
    };

    virtual void OnRspAuthenticate(CQdpFtdcRtnAuthenticateField *pRtnAuthenticate, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "用户认证失败; 原因: " << pRspInfo->ErrorMsg << "\n";
            // REPORT_EVENT(LOG_ERROR, "CAccountSpi::OnRspUserLogin", "Login result: %s", "failed");
            return;
        }
        if (pRspInfo == NULL)
        {
            std::cout << "OnRspAuthenticate=NULL!\n";
        }
        TQdpFtdcAppTypeType *appType = pRtnAuthenticate->AppID;

        std::cout << "认证成功，客户接入类型为: " << appType << "\n";

        // 认证成功后登录
        ReqLogin();
    };
    // traderSPI
    virtual void OnRtnTrade(CQdpFtdcTradeField *pTrade)
    {
        std::cout << "OnRtnTrade: OrderSysID=" << pTrade->OrderSysID << ", TradeID=" << pTrade->TradeID << "\n";
    };
    virtual void OnRtnOrder(CQdpFtdcOrderField *pOrder) {
        // store OrderSysID
        std::cout << "OnRtnOrder: OrderSysID=" << pOrder->OrderSysID << ", InstrumentID=" << pOrder->InstrumentID << "\n";
    };
    virtual void OnRtnInstrumentStatus(CQdpFtdcInstrumentStatusField *pInstrumentStatus) {};

    // virtual void OnErrRtnOrderInsert(CQdpFtdcInputOrderField* pInputOrder, CQdpFtdcRspInfoField* pRspInfo){};

    virtual void OnRspOrderAction(CQdpFtdcOrderActionField *pOrderAction, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if(pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "用户报单操作失败;原因:" << pRspInfo->ErrorMsg << "\n";
            return;
        }
        if(pRspInfo == NULL){
            std::cout << "OnRspOrderAction=NULL!\n";
        }
    };
    // QuerySPI
    virtual void OnRspQryUserInvestor(CQdpFtdcRspUserInvestorField *pRspUserInvestor, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "可用InvestorID:" << pRspUserInvestor->InvestorID
                  << "对应UserID:" << pRspUserInvestor->UserID << "\n";
    };
    // virtual void OnRspQryInvestor(CQdpFtdcRspQryInvestorField *pRspQryInvestor, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast){};
    virtual void OnRspQryInvestorPosition(CQdpFtdcRspInvestorPositionField *pRspInvestorPosition, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "持仓查询\n";
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "持仓查询用户操作失败; 错误码: " << pRspInfo->ErrorID
                      << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }

        if (pRspInvestorPosition != NULL)
        {
            // 总持仓成本 总持仓量 合约乘数
            std::cout << "持仓查询操作成功, 占用保证金=[" << pRspInvestorPosition->UsedMargin
                      << "], 冻结保证金=[" << pRspInvestorPosition->FrozenMargin << "], 合约代码=[" << pRspInvestorPosition->InstrumentID << "], 冻结权利金=[" << pRspInvestorPosition->FrozenPremium << "], 持仓盈亏=[" << pRspInvestorPosition->PositionProfit << "], 今日持仓成本=[" << pRspInvestorPosition->PositionCost << "], 今持仓量=[" << pRspInvestorPosition->TodayPosition << "];\n";
        }
    };
    virtual void OnRspQryInstrument(CQdpFtdcRspInstrumentField *pRspInstrument, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "查询合约编号\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "查询合约编号操作失败; 错误码: " << pRspInfo->ErrorID
                      << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }

        if (pRspInstrument != NULL)
        {
            std::cout << "查询合约编号操作成功, 交易所代码=[" << pRspInstrument->ExchangeID
                      << "], 合约代码=[" << pRspInstrument->InstrumentID 
                      << "], 数量乘数=[" << pRspInstrument->VolumeMultiple
                      //<< "], InstrumentIDNum=" << pRspInstrument->InstrumentIDNum //在API7.0版本中，报单时填写InstrumentIDNum
                      << "], 合约名称=[" << pRspInstrument->InstrumentName << "], 报价单位=[" << pRspInstrument->PriceTick << "], 跌停板价=[" << pRspInstrument->LowerLimitPrice << "], 昨天结算=[" << pRspInstrument->PreSettlementPrice << "], 合约交易状态=[" << pRspInstrument->InstrumentStatus << "], 当前是否交易=[" << pRspInstrument->IsTrading << "], 上市日 | 挂牌基准价 | 执行价格=[" << pRspInstrument->OpenDate
                      << "|" << pRspInstrument->BasisPrice << "|" << pRspInstrument->StrikePrice << "];\n";
        }
    };
    virtual void OnRspQryInvestorAccount(CQdpFtdcRspInvestorAccountField *pRspInvestorAccount, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "投资者资金账户查询\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "投资者资金账户查询操作失败; 错误码: " << pRspInfo->ErrorID
                      << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }

        if (pRspInvestorAccount != NULL)
        {
            std::cout << "操作成功, 资金账号=[" << pRspInvestorAccount->AccountID
                      << "], 上次结算准备金=[" << pRspInvestorAccount->PreBalance << "], 上日可用资金=[" << pRspInvestorAccount->PreAvailable << "], 平仓/持仓盈亏=[" << pRspInvestorAccount->CloseProfit << "|" << pRspInvestorAccount->PositionProfit << "], 手续费=[" << pRspInvestorAccount->Fee << "], 冻结手续费=[" << pRspInvestorAccount->FrozenFee << "], 冻结权利金=[" << pRspInvestorAccount->FrozenPremium << "], 占用保证金=[" << pRspInvestorAccount->Margin << "], 冻结保证金=[" << pRspInvestorAccount->FrozenMargin << "], 可用资金=[" << pRspInvestorAccount->Available << "], 动态权益=[" << pRspInvestorAccount->DynamicRights << "], 结算准备金=[" << pRspInvestorAccount->Balance << "], 入金/出金=[" << pRspInvestorAccount->Deposit << "|" << pRspInvestorAccount->Withdraw << "], 手续费=[" << pRspInvestorAccount->Fee << "];\n";
        }

        if (pRspInvestorAccount == NULL)
        {
            std::cout << "pRspInvestorAccount=NULL\n";
        }
    };
    virtual void OnRspQryInvestorMargin(CQdpFtdcInvestorMarginField *pInvestorMargin, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "保证金率查询\n";
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "保证金率查询操作失败; 错误码: " << pRspInfo->ErrorID
                      << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }
        if (pInvestorMargin != NULL)
        {
            std::cout << "保证金率查询操作成功, InstrumentID=[" << pInvestorMargin->InstrumentID
                      << "], LongMarginRate=[" << pInvestorMargin->LongMarginRate
                      << "], LongMarginAmt=[" << pInvestorMargin->LongMarginAmt
                      << "], ShortMarginRate=[" << pInvestorMargin->ShortMarginRate
                      << "], ShortMarginAmt=[" << pInvestorMargin->ShortMarginAmt
                      << "], HedgeFlag=[" << pInvestorMargin->HedgeFlag
                      << "];" << "\n";
        }
    };
    virtual void OnRspQryInvestorFee(CQdpFtdcInvestorFeeField *pInvestorFee, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "手续费率查询\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "手续费率查询操作失败; 错误码: " << pRspInfo->ErrorID
                      << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }

        if (pInvestorFee == NULL)
            std::cout << "OnRspQryInvestorFee pInvestorFee=NULL\n";
    };
    virtual void OnRspQryInvestorOptionFee(CQdpFtdcRspInvestorOptionFeeField *pRspInvestorOptionFee, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "期权手续费率查询\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "期权手续费率查询操作失败; 错误码: " << pRspInfo->ErrorID
                      << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }
    };

    virtual void OnRspQryMarketData(CQdpFtdcMarketDataField *pMarketData, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "合约行情查询\n";
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "合约行情查询操作失败; 错误码: " << pRspInfo->ErrorID
                      << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }
    };

    virtual void OnRspQryExchange(CQdpFtdcRspExchangeField *pRspExchange, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "交易所查询\n";
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "交易所查询操作失败; 错误码: " << pRspInfo->ErrorID
                      << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }
    };
    virtual void OnRspQryTrade(CQdpFtdcTradeField *pTrade, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        if (pTrade == NULL)
            std::cout << "OnRspQryTrade pTrade=NULL\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "用户操作失败; 错误码: " << pRspInfo->ErrorID
                      << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }
    };

    virtual void OnRspQryOrder(CQdpFtdcOrderField *pOrder, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        // 报单查询
        if (pOrder == NULL)
            std::cout << "OnRspQryOrder pOrder=NULL\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "报单查询失败; 错误码: " << pRspInfo->ErrorID
                        << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID;
            return;
        }
    };

   
    virtual void OnRspQuoteAction(CQdpFtdcQuoteActionField *pQuoteAction, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "用户操作失败; 错误码: " << pRspInfo->ErrorID
                        << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID;
            return;
        }
        if (pQuoteAction != NULL)
        {
            
            std::cout << "报价撤销操作成功, UserOrderLocalID=[" << pQuoteAction->UserOrderLocalID
                << "], OrderSysID=[" << pQuoteAction->OrderSysID
                << "];\n";
        }
    };
   
    virtual void OnRtnQuote(CQdpFtdcQuoteField *pQuote) {
        // 报价回报
        std::cout << "OnRtnQuote/报价回报, OrderSysID=" << pQuote->OrderSysID << ", UserOrderLocalID=" << pQuote->UserOrderLocalID << "\n";
    };
    
    virtual void OnRspOrderInsert(CQdpFtdcInputOrderField *pRspInputOrder, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "下单失败, 原因: " << pRspInfo->ErrorMsg << "; 错误码:" << pRspInfo->ErrorID << "\n";
            return;
        }

        if (pRspInputOrder != NULL)
	    {
             std::cout << "下单成功,LimitPrice=[" << pRspInputOrder->LimitPrice
                << "],InstrumentID=[" << pRspInputOrder->InstrumentID
                << "],Volume=[" << pRspInputOrder->Volume
                << "],UserOrderLocalID=[" << pRspInputOrder->UserOrderLocalID
                << "],OrderSysID=[" << pRspInputOrder->OrderSysID
                << "];\n" ;
        }
    };

    virtual void OnRspQryForQuote(CQdpFtdcForQuoteField *pForQuote, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if( pRspInfo != NULL && pRspInfo->ErrorID != 0){
            std::cout << "询价查询失败; 错误码: " << pRspInfo->ErrorID << "\n";
            return;
        }

        if( pForQuote == NULL){
            std::cout << "OnRspQryForQuote pInputForQuote=NULL\n";
        }
    };

    virtual void OnRspForQuoteInsert(CQdpFtdcInputForQuoteField *pInputForQuote, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "询价录入失败; 错误码: " << pRspInfo->ErrorID << "\n";
            return;
        }

        if (pInputForQuote == NULL){
            std::cout << "OnRspForQuoteInsert pInputForQuote=NULL\n";
        }
    };

    virtual void OnRspQuoteInsert(CQdpFtdcInputQuoteField *pRspInputQuote, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "报价录入失败; 错误码: " << pRspInfo->ErrorID
                        << ", 原因: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }

        if (pRspInputQuote != NULL)
        {
            std::cout << "报价成功,InstrumentID=[" << pRspInputQuote->InstrumentID
                      << "],AskPrice=[" <<  pRspInputQuote->AskPrice
                      << "],AskVolume=[" << pRspInputQuote->AskVolume
                      << "],BidPrice=[" << pRspInputQuote->BidPrice
                      << "],BidVolume=[" << pRspInputQuote->BidVolume << "\n";
        }
    };

private:
    CQdpFtdcTraderApi *m_pTraderApi;
    std::thread orderThread;
    int session_id;
};

void ReqQryTopic(int RequestID)
{
    CQdpFtdcDisseminationField t_field;
    memset(&t_field, 0, sizeof(t_field));
    t_field.SequenceNo = 1;
    t_field.SequenceSeries = 2000;
    g_pTraderApi->ReqQryTopic(&t_field, RequestID);
}

void ReqUserPasswordUpdate(int RequestID)
{
    CQdpFtdcUserPasswordUpdateField t_field;
    memset(&t_field, 0, sizeof(t_field));
    strcpy(t_field.BrokerID, g_chBrokerID);
    strcpy(t_field.UserID, g_chUserID);
    strcpy(t_field.OldPassword, "1");
    strcpy(t_field.NewPassword, "1");
    g_pTraderApi->ReqUserPasswordUpdate(&t_field, RequestID);
}

void ReqSubPrdTradeFlow(int RequestID)
{
    CQdpFtdcSpecificInstrumentField t_field;
    memset(&t_field, 0, sizeof(t_field));
    strcpy(t_field.InstrumentID, "CFFEX");
    g_pTraderApi->ReqSubPrdTradeFlow(&t_field, RequestID);
}

void ReqUnSubPrdTradeFlow(int RequestID)
{
    CQdpFtdcSpecificInstrumentField t_field;
    memset(&t_field, 0, sizeof(t_field));
    strcpy(t_field.InstrumentID, "CFFEX");
    g_pTraderApi->ReqUnSubPrdTradeFlow(&t_field, RequestID);
}

void ReqForQuoteInsert(int RequestID)
{
    CQdpFtdcInputForQuoteField a_field;
    memset(&a_field, 0, sizeof(a_field));
    strcpy(a_field.BrokerID, g_chBrokerID);
    strcpy(a_field.InvestorID, g_chInvestorID);
    strcpy(a_field.UserID, g_chUserID);
    strcpy(a_field.ExchangeID, "CFFEX");
    strcpy(a_field.InstrumentID, "IF2412");
    a_field.UserOrderLocalID = 5;
    g_pTraderApi->ReqForQuoteInsert(&a_field, RequestID);
}

void ReqQryForQuote(int RequestID)
{
    CQdpFtdcQryForQuoteField a_field;
    memset(&a_field, 0, sizeof(a_field));
    strcpy(a_field.BrokerID, g_chBrokerID);
    strcpy(a_field.InvestorID, g_chInvestorID);
    strcpy(a_field.ExchangeID, "CFFEX");
    strcpy(a_field.InstrumentID, "IF2412");
    g_pTraderApi->ReqQryForQuote(&a_field, RequestID);
}

void ReqQryMarketData(int RequestID)
{
    CQdpFtdcQryMarketDataField d_field;
    memset(&d_field, 0, sizeof(CQdpFtdcQryMarketDataField));
    strcpy(d_field.ExchangeID, "CFFEX");
    strcpy(d_field.InstrumentID, "IF2412");
    g_pTraderApi->ReqQryMarketData(&d_field, RequestID);
}

void ReqQryExchange(int &RequestID)
{
    CQdpFtdcQryExchangeField t_field;
    memset(&t_field, 0, sizeof(CQdpFtdcQryExchangeField));
    strcpy(t_field.ExchangeID, "CFFEX");
    g_pTraderApi->ReqQryExchange(&t_field, RequestID);
}

void ReqQryTrade(int &RequestID)
{
    CQdpFtdcQryTradeField t_field;
    memset(&t_field, 0, sizeof(CQdpFtdcQryTradeField));
    strcpy(t_field.BrokerID, g_chBrokerID);
    strcpy(t_field.UserID, g_chUserID);
    g_pTraderApi->ReqQryTrade(&t_field, RequestID);
}

void ReqQryOrder(int &RequestID)
{
    CQdpFtdcQryOrderField o_field;
    memset(&o_field, 0, sizeof(CQdpFtdcQryOrderField));
    strcpy(o_field.BrokerID, g_chBrokerID);
    strcpy(o_field.UserID, g_chUserID);
    g_pTraderApi->ReqQryOrder(&o_field, RequestID);
}

void ReqQuoteAction(int RequestID)
{
    CQdpFtdcQuoteActionField quote;
    memset(&quote, 0, sizeof(quote));
    quote.UserOrderLocalID = 5;
    strcpy(quote.ExchangeID, "CFFEX");
    quote.UserOrderActionLocalID = ++g_nOrdLocalID;
    quote.ActionFlag = QDP_FTDC_AF_Delete;
    g_pTraderApi->ReqQuoteAction(&quote, RequestID);
}

void ReqQuoteInsert(int RequestID)
{
    CQdpFtdcInputQuoteField quote;
    memset(&quote, 0, sizeof(quote));
    // 合约号
    strcpy(quote.InstrumentID,"IF2412");
    // 本地报单号
    quote.UserOrderLocalID = g_nOrdLocalID;
    // 投资者IDNum
    strcpy(quote.InvestorID,g_chInvestorID);

    // 卖出参数
    quote.AskOffsetFlag = '0';
    quote.AskHedgeFlag = '0';
    quote.AskPrice = 1000;
    quote.AskVolume = 5;
    quote.AskOrderRef = g_nOrdLocalID++;
    // 买入参数
    quote.BidOffsetFlag = '0';
    quote.BidHedgeFlag = '0';
    quote.BidPrice = 1231;
    quote.BidVolume = 10;
    quote.BidOrderRef = g_nOrdLocalID++;

    g_pTraderApi->ReqQuoteInsert(&quote, RequestID);
}

void ReqSubmitUserSystemInfo(int RequestID)
{
    CQdpFtdcUserSystemInfoField a_field;
    memset(&a_field, 0, sizeof(a_field));

    g_pTraderApi->ReqSubmitUserSystemInfo(&a_field, RequestID);
}

void ReqQryFrontInfo(int RequestID)
{
    CQdpFtdcQryFrontInfoField a_field;
    memset(&a_field, 0, sizeof(a_field));
    strcpy(a_field.ExchangeID, "CFFEX");
    g_pTraderApi->ReqQryFrontInfo(&a_field, RequestID);
}

int ReqSetClientMaxSigVol(int RequestID)
{
    CQdpFtdcClientMaxSigVolField a_field;
    memset(&a_field, 0, sizeof(a_field));
    strcpy(a_field.BrokerID, g_chBrokerID);
    strcpy(a_field.ExchangeID, "CFFEX");
    strcpy(a_field.InvestorID, g_chInvestorID);
    a_field.HedgeFlag = '1';
    // strcpy(a_field.InstrumentID,"");
    // a_field.MaxSigVol = 10;
    return g_pTraderApi->ReqSetClientMaxSigVol(&a_field, RequestID);
}

int ReqOrderAction(int RequestID)
{
    CQdpFtdcOrderActionField ord;
    memset(&ord, 0, sizeof(ord));
    // 交易所
    strcpy(ord.ExchangeID, "SHFE");
    // 被撤订单的本地报单编号
    ord.UserOrderLocalID = g_nOrdLocalID++;
    // 本次撤单操作的本地编号
    ord.UserOrderActionLocalID = 5;
    // 报单编号
    strcpy(ord.OrderSysID, "23");
    // 报单操作标志
    ord.ActionFlag = QDP_FTDC_AF_Delete;

    return g_pTraderApi->ReqOrderAction(&ord, RequestID);
}

int ReqOrderInsert(int RequestID)
{
    CQdpFtdcInputOrderField ord;
    memset(&ord, 0, sizeof(ord));
    // 投资者编号 (对于API7.0版本,InstrumentIDNum通过合约查询的回调获取)
    strcpy(ord.InvestorID,g_chInvestorID);
    // 合约号
    strcpy(ord.InstrumentID,"IF2412");
    // 本地报单号
    ord.UserOrderLocalID = g_nOrdLocalID;
    // 报单类型
    ord.OrderPriceType = QDP_FTDC_OPT_LimitPrice;
    // 买卖方向
    // strcpy(&(ord.Direction) , "1");
    ord.Direction = QDP_FTDC_D_Buy;
    // 开平标志
    strcpy(&(ord.OffsetFlag), "0");
    // 投机套保标志
    strcpy(&(ord.HedgeFlag), "1");
    // 价格
    ord.LimitPrice = 3074;
    // 数量
    ord.Volume = 1;
    // 有效期类型
    ord.TimeCondition = QDP_FTDC_TC_GFD;
    // 成交量类型
    ord.VolumeCondition = QDP_FTDC_VC_AV;

    return g_pTraderApi->ReqOrderInsert(&ord, RequestID);
}

int ReqQryUserInvestor(int RequestID)
{
    CQdpFtdcQryUserInvestorField a_field;
    memset(&a_field, 0, sizeof(CQdpFtdcQryUserInvestorField));
    strcpy(a_field.BrokerID, g_chBrokerID);
    strcpy(a_field.UserID, g_chUserID);
    return g_pTraderApi->ReqQryUserInvestor(&a_field, RequestID);
}

int ReqQryInvestorAccount(int RequestID)
{
    CQdpFtdcQryInvestorAccountField a_field;
    memset(&a_field, 0, sizeof(CQdpFtdcQryInvestorAccountField));
    strcpy(a_field.BrokerID, g_chBrokerID);
    strcpy(a_field.UserID, g_chUserID);
    strcpy(a_field.InvestorID, g_chInvestorID);
    return g_pTraderApi->ReqQryInvestorAccount(&a_field, RequestID);
}

int ReqQryInvestorOptionFee(int RequestID)
{
    CQdpFtdcQryInvestorOptionFeeField of_field;
    memset(&of_field, 0, sizeof(CQdpFtdcQryInvestorOptionFeeField));
    strcpy(of_field.BrokerID, g_chBrokerID);
    strcpy(of_field.UserID, g_chUserID);
    return g_pTraderApi->ReqQryInvestorOptionFee(&of_field, RequestID);
}

int ReqQryInvestorMargin(int RequestID)
{
    CQdpFtdcQryInvestorMarginField m_field;
    memset(&m_field, 0, sizeof(CQdpFtdcQryInvestorMarginField));
    return g_pTraderApi->ReqQryInvestorMargin(&m_field, RequestID);
}

int ReqQryInstrument(int RequestID)
{
    CQdpFtdcQryInstrumentField i_field;
    memset(&i_field, 0, sizeof(CQdpFtdcQryInstrumentField));
    return g_pTraderApi->ReqQryInstrument(&i_field, RequestID);
}

int ReqQrySGEDeferRate(int RequestID)
{
    CQdpFtdcQrySGEDeferRateField s_field;
    memset(&s_field, 0, sizeof(CQdpFtdcQrySGEDeferRateField));
    return g_pTraderApi->ReqQrySGEDeferRate(&s_field, RequestID);
}

int ReqQryInvestorFee(int RequestID)
{
    CQdpFtdcQryInvestorFeeField f_field;
    memset(&f_field, 0, sizeof(CQdpFtdcQryInvestorFeeField));
    strcpy(f_field.BrokerID, g_chBrokerID);
    strcpy(f_field.UserID, g_chUserID);
    return g_pTraderApi->ReqQryInvestorFee(&f_field, RequestID);
}

int ReqQryInvestorPosition(int RequestID)
{
    CQdpFtdcQryInvestorPositionField p_field;
    memset(&p_field, 0, sizeof(CQdpFtdcQryInvestorPositionField));
    strcpy(p_field.BrokerID, g_chBrokerID);
    strcpy(p_field.UserID, g_chUserID);
    strcpy(p_field.ExchangeID, "CFFEX");
    strcpy(p_field.InvestorID, g_chInvestorID);
    strcpy(p_field.InstrumentID, "IF2412");
    return g_pTraderApi->ReqQryInvestorPosition(&p_field, RequestID);
}

void OrderFunc()
{
    //注释了报价相关的请求 需要时打开
    std::this_thread::sleep_for(std::chrono::microseconds(5000));
    std::cout << "开始查询和报单过程\n";
    int RequestID = 0;
    // 操作类型
    int operationType = 0;
    while(1){
        //接受用户输入 执行对应的查询和报单操作
        std::cout << "输入数字执行对应的操作:" << std::endl;
        std::cin >> operationType;
        switch (operationType)
        {
        case 1:
            // 合约查询请求
            ReqQryInstrument(RequestID);
            break;
        case 2:
            // 报单录入请求
            ReqOrderInsert(RequestID);
            break;
        case 3:
            // 报单操作请求
            ReqOrderAction(RequestID);
            break;
        case 4:
            // 客户信息量阈值设置请求
            ReqSetClientMaxSigVol(RequestID);
            break;
        case 5:
            // 可用投资者账户查询请求
            ReqQryUserInvestor(RequestID);
            break;
        case 6:
            // 投资者资金账户查询请求
            ReqQryInvestorAccount(RequestID);
            break;
        case 7:
            // 投资者持仓查询请求
            ReqQryInvestorPosition(RequestID);
            break;
        case 8:
            // 投资者手续费率查询请求
            ReqQryInvestorFee(RequestID);
            break;
        case 9:
            // 投资者保证金率查询请求
            ReqQryInvestorMargin(RequestID);
            break;
        case 10:
            // 金交所递延费率查询请求
            ReqQrySGEDeferRate(RequestID);
            break;
        case 11:
            // 投资者期权手续费率查询请求
            ReqQryInvestorOptionFee(RequestID);
            break;
        case 12:
            // 报价录入请求
            // ReqQuoteInsert(RequestID);
            break;
        case 13:
            // 报价操作请求
            // ReqQuoteAction(RequestID);
            break;
        case 14:
            // 交易通道信息查询请求
            ReqQryFrontInfo(RequestID);
            break;
        case 15:
            // 用户采集信息发送请求
            // ReqSubmitUserSystemInfo(RequestID);
            break;
        case 16:
            // 报单查询请求
            ReqQryOrder(RequestID);
            break;
        case 17:
            // 成交单查询请求
            ReqQryTrade(RequestID);
            break;
        case 18:
            // 交易所查询请求
            ReqQryExchange(RequestID);
            break;
        case 19:
            // 实时行情查询请求
            ReqQryMarketData(RequestID);
            break;
        case 20:
            // 询价查询请求
            // ReqQryForQuote(RequestID);
            break;
        case 21:
            // 询价录入请求
            // ReqForQuoteInsert(RequestID);
            break;
        case 22:
            // 订阅品种交易流水
            //ReqSubPrdTradeFlow(RequestID);
            break;
        case 23:
            // 退订订阅品种交易流水
            //ReqUnSubPrdTradeFlow(RequestID);
            break;
        case 24:
            // 用户密码修改请求
            ReqUserPasswordUpdate(RequestID);
            break;
        case 25:
            //主题查询请求
            // ReqQryTopic(RequestID);
            break;
        default:
            break;
        }
        RequestID++;
    }
}

int main()
{
    // 产生一个CQdpFtdcTraderApi实例
    CQdpFtdcTraderApi *pUserApi = CQdpFtdcTraderApi::CreateFtdcTraderApi();
    
    // 保存api
    g_pTraderApi = pUserApi;
    
    //获取API版本号
    int max_version,min_version;
    std::cout << "API版本号:" << CQdpFtdcTraderApi::GetVersion(max_version,min_version);
    
    // 产生一个事件处理的实例
    CTraderSpi *spi = new CTraderSpi(pUserApi);

    // 注册事件处理的实例
    pUserApi->RegisterSpi(spi);
    // 订阅私有流
    // QDP_TERT_RESTART:从本交易日开始重传
    // QDP_TERT_RESUME:从上次收到的续传
    // QDP_TERT_QUICK:只传送登录后私有流的内容
    pUserApi->SubscribePrivateTopic(QDP_TERT_QUICK);
    // 订阅公共流
    // QDP_TERT_RESTART:从本交易日开始重传
    // QDP_TERT_RESUME:从上次收到的续传
    // QDP_TERT_QUICK:只传送登录后私有流的内容
    pUserApi->SubscribePublicTopic(QDP_TERT_QUICK);

    // 设置BrokerID 和 UserID
    strcpy(g_chBrokerID, "guofu");
    strcpy(g_chUserID, "admin");
    strcpy(g_chInvestorID, "0001"); 

    // 设置量投科技服务的地址，可以注册多个地址备用
    pUserApi->RegisterFront("tcp://192.168.92.212:30005");

    // 设置心跳超时
    pUserApi->SetHeartbeatTimeout(240);

    // 使客户端开始与后台服务建立连接
    pUserApi->Init();
    // 等待API实例
    pUserApi->Join();
    // 释放API实例
    pUserApi->Release();
    return 0;
}